<%-- 
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of the Example Code Package for BASE.
	Available at http://baseplugins.thep.lu.se/
	BASE main site: http://base.thep.lu.se/
	
	This is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	The software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
--%>
<%@ page 
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Registered"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Ownable"
	import="net.sf.basedb.core.Reporter"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
try
{
	String name = null;
	Date registered = null;
	boolean isShared = false;
	boolean isRemoved = false;
	boolean isOwnedByYou = false;
	if (itemType.getItemClass() != null)
	{
		BasicItem item = itemType.getById(dc, itemId);
		name = item instanceof Nameable ? ((Nameable)item).getName() : item.toString();
		if (item instanceof Registered) registered = ((Registered)item).getEntryDate();
		if (item instanceof Shareable) isShared = ((Shareable)item).isShared();
		if (item instanceof Removable) isRemoved = ((Removable)item).isRemoved();
		if (item instanceof Ownable) isOwnedByYou = ((Ownable)item).isOwner();
	}
	else if (itemType == Item.REPORTER)
	{
		ReporterData reporter = Reporter.getById(dc, itemId);
		name = reporter.getName();
		registered = reporter.getEntryDate();
	}

	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	%>
	<base:page type="popup" title="Item information">
	<base:head />
	<base:body>
		<h1>Item information</h1>
		<div class="content bottomborder">
			
			<table class="fullform larger">
			<tr>
				<th>Type</th>
				<td><%=itemType.name()%></td>
			</tr>
			<tr>
				<th>ID</th>
				<td><%=itemId%></td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=name == null ? "<i>unknown</i>" : HTML.niceFormat(name)%></td>
			</tr>
			<tr>
				<th>Registration date</th>
				<td><%=registered == null ? "<i>unknown</i>" : dateFormatter.format(registered)%></td>
			</tr>
			<tr>
				<th>Owned by you?</th>
				<td><%=isOwnedByYou ? "yes" : "no"%></td>
			</tr>
			<tr>
				<th>Shared to other users?</th>
				<td><%=isShared ? "yes" : "no"%></td>
			</tr>
			<tr>
				<th>Marked for removal?</th>
				<td><%=isRemoved ? "yes" : "no"%></td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="window.close()" title="Close" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
